/******************************************************************************
 *	csfile.c:	t@C̃[hAZ[u֐
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 */
#include <stdio.h>
#include <string.h>
#include <doslib.h>
#include <dialog.h>		/* _CAO}𗘗pƂɕKv	*/
#include <task.h>		/* ^XN}𗘗pƂɕKv	*/
#include "cash.h"		/* ̃vOŗL̃wb_t@C	*/
#include "csfile.h"		/* f[^t@C̃wb_t@C */

/******************************************************************************
 *	loadFile():	w̓t̃f[^t@Cǂݍ
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int month	
 *		int day		
 *		int *tMoney	zi[|C^
 *		char *tInfo	Evi[|C^
 *	߂l:	BOOLEAN		= TRUE:  ǂݍݐ
 *				= FALSE: ǂݍݎs
 */
BOOLEAN loadFile(ComVal *pcv, int month, int day, int *tMoney, char *tInfo)
{
	int i, errCode, len;
	short sp;
	short index[512];		/* f[^̈ʒue[u		*/
	FILE *hFile;			/* t@Cnh		*/
	KZDATA kzBuff;			/* t@CPR[hobt@	*/

	/* hCuǂݍ݃[hŃ`FbN */
	errCode = checkDrive(pcv->dataFile, 1);
	if (errCode < 0) {
		if (errCode == -4) {
			/* t@CtȂꍇ */
			DMError(D_CONFIRM, "f[^t@Ct܂B\r"
					   "VK쐬܂B");
			if(!newFile(pcv))
				return FALSE;

			clearData(pcv->money, pcv->info[0]);
			return TRUE;

		} else
			/* ǂݍ݂sȂꍇ */
			return FALSE;
	}
	/* t@CI[v */
	hFile = fopen(pcv->dataFile, "rb");
	if (hFile == NULL) {
		/* t@CI[vłȂ */
		DMError(D_CONFIRM, "t@CI[vł܂B");
		clearData(tMoney, tInfo);
		return FALSE;
	}
	fseek(hFile, 0, SEEK_SET);
	len = fread(index, sizeof(short), 512, hFile);
	if (len != 512) {
		DMError(D_CONFIRM, "f[^t@C̍\ُłB");
		fclose(hFile);
		return FALSE;
	}
	/* w̓t܂ł̃V[Nʒu߂ */
	sp = index[(month - 1) * 32 + (day - 1)];
	if (sp == -1) {
		/* f[^VK쐬 */
		clearData(tMoney, tInfo);
		fclose(hFile);
		return TRUE;
	}
	sp *= sizeof(KZDATA);
	if (fseek(hFile, sp + 1024, SEEK_SET)) {
		/* f[^ʒu܂ŃV[NłȂ */
		DMError(D_CONFIRM, "f[^t@C̍\ُłB");
		fclose(hFile);
		return FALSE;
	}
	/* f[^̓ǂݍ */
	len = fread((unsigned char *) &kzBuff, sizeof(KZDATA), 1, hFile);
	if (len != 1) {
		/* ǂݍ݃G[̏ꍇ */
		DMError(D_CONFIRM, "t@C̓ǂݍ݂Ɏs܂B");
		clearData(tMoney, tInfo);
		fclose(hFile);
		return FALSE;
	}
	/* obt@̃f[^f[v */
	for (i = 0; i < 7; i++)
		tMoney[i] = kzBuff.money[i];
	memcpy(tInfo, kzBuff.info, 7 * 21);
	/* t@CN[Y */
	fclose(hFile);
	return TRUE;
}

/******************************************************************************
 *	newFile():	VKt@C쐬
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬s
 */
BOOLEAN newFile(ComVal *pcv)
{
	int i, len;
	short index[512];
	FILE *hFile;

	/* f[^̈ʒue[u쐬 */
	for (i = 0; i < 16; i++)
		index[i] = -1;
	/* xɂ܂Ƃ߂ăhԂ */
	for (i = 1; i < 32; i++)
		memcpy(&index[i*16], &index[(i - 1) * 16], 32);
	/* VKt@CƂăI[v */
	hFile = fopen(pcv->dataFile, "ab+");
	if (hFile == NULL) {
		DMError(D_CONFIRM, "t@C쐬ł܂B");
		return FALSE;
	}
	/* e[ut@Cɏ */
	fseek(hFile, 0, SEEK_SET);	/* t@C̐擪Ɉړ */
	len = fwrite(index, sizeof(short), 512, hFile);
	if (len != 512) {
		DMError(D_CONFIRM, "t@C݂̏ł܂B");
		fclose(hFile);
		return FALSE;
	}

	fclose(hFile);
	return TRUE;
}

/******************************************************************************
 *	readTable():	f[^t@C̈ʒue[uǂݏo
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  ǂݍݐ
 *				= FALSE: ǂݍݎs
 *	:
 *	f[^̔zũe[uf[^t@Cǂݏo܂B
 */
BOOLEAN readTable(ComVal *pcv, short *index)
{
	int errCode, len;
	FILE *hFile;

	/* hCuǂݍ݃[hŃ`FbN */
	errCode = checkDrive(pcv->dataFile, 1);
	if (errCode < 0) {
		if (errCode == -4)
			DMError(D_CONFIRM, "f[^t@C݂܂B");
		return FALSE;		/* ǂݍ݂sȂꍇ */
	}
	/* t@CI[v */
	hFile = fopen(pcv->dataFile, "rb");
	if (hFile == NULL) {
		/* t@CI[vłȂ */
		DMError(D_CONFIRM, "t@CI[vł܂B");
		return FALSE;
	}
	len = fread(index, sizeof(short), 512, hFile);
	if (len != 512) {
		DMError(D_CONFIRM, "f[^t@C̍\ُłB");
		fclose(hFile);
		return FALSE;
	}

	fclose(hFile);
	return TRUE;
}

/******************************************************************************
 *	saveFile():	w̓t̃f[^t@CɃZ[u
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		int month	
 *		int day		
 *		int *tMoney	zi[|C^
 *		char *tInfo	Evi[|C^
 *	߂l:	BOOLEAN		= TRUE:  ǂݍݐ
 *				= FALSE: ǂݍݎs
 */
BOOLEAN saveFile(ComVal *pcv, int month, int day, int *tMoney, char *tInfo)
{
	int errCode, len;
	short sp, index[512];
	long flen;			/* t@C̃TCY		*/
	FILE *hFile;			/* t@Cnh		*/

	/* hCu݃[hŃ`FbN */
	errCode = checkDrive(pcv->dataFile, 0);
	if (errCode < 0) {
		if (errCode == -4)
			/* t@CtȂ̂ŐVKɃt@C쐬 */
			/* f[^̈ʒue[u쐬 */
			return newFile(pcv);

		else
			/* ݂sȂꍇ */
			return FALSE;

	} else
		/* ̃t@CI[v */
		hFile = fopen(pcv->dataFile, "rb+");
	if (hFile == NULL) {
		errSaveFile(NULL, 1);	/* G[bZ[W\ */
		return FALSE;
	}
	/* t@C̈ʒu擪Ɉړ */
	fseek(hFile, 0, SEEK_SET);
	/* f[^̈ʒue[uǂݍ */
	len = fread(index, sizeof(short), 512, hFile);
	if (len != 512) {
		/* ǂݍ݃G[̏ꍇ */
		errSaveFile(hFile, 2);	/* G[bZ[W\ */
		return FALSE;
	}
	sp = index[(month - 1) * 32 + (day - 1)];
	if (sp == -1) {
		/* VK̃f[^̏ꍇ */
		if (fseek(hFile, 0, SEEK_END)) {
			/* f[^ʒu܂ŃV[NłȂ */
			errSaveFile(hFile, 2);	/* G[bZ[W\ */
			return FALSE;
		}
		/* VKf[^݈̏ʒu */
		flen = ftell(hFile);
		if (flen < 0) {
			/* f[^ʒu܂ŃV[NłȂ */
			errSaveFile(hFile, 2);	/* G[bZ[W\ */
			return FALSE;
		}
		sp = (flen - 1024) / sizeof(KZDATA);
		/* e[ut@Cɏ */
		index[(month - 1) * 32 + (day - 1)] = sp;
		fseek(hFile, 0, SEEK_SET);
		len = fwrite(index, sizeof(short), 512, hFile);
		if (len != 512) {
			errSaveFile(hFile, 3);	/* G[bZ[W\ */
			return FALSE;
		}
		fseek(hFile, 0, SEEK_END);
	} else {
		sp *= sizeof(KZDATA);
		if (fseek(hFile, sp + 1024, SEEK_SET)) {
			/* f[^ʒu܂ŃV[NłȂ */
			errSaveFile(hFile, 2);	/* G[bZ[W\ */
			return FALSE;
		}
	}
	/* t@C|C^Ƀf[^ */
	/*  */
	len = fwrite((unsigned char *) &month, sizeof(int), 1, hFile);
	if (len != 1) {
		errSaveFile(hFile, 3);	/* G[bZ[W\ */
		return FALSE;
	}
	/*  */
	len = fwrite((unsigned char *) &day, sizeof(int), 1, hFile);
	if (len != 1) {
		errSaveFile(hFile, 3);	/* G[bZ[W\ */
		return FALSE;
	}
	/* z */
	len = fwrite((unsigned char *) tMoney, sizeof(int), 7, hFile);
	if (len != 7) {
		errSaveFile(hFile, 3);	/* G[bZ[W\ */
		return FALSE;
	}
	/* Ev */
	len = fwrite((unsigned char *) tInfo, sizeof(char), 7 * 21, hFile);
	if (len != (7 * 21)) {
		errSaveFile(hFile, 3);	/* G[bZ[W\ */
		return FALSE;
	}
	/* f[^ʂɕ␳ */
	len = fwrite((unsigned char *) "", sizeof(char), 1, hFile);
	if (len != 1) {
		errSaveFile(hFile, 3);	/* G[bZ[W\ */
		return FALSE;
	}

	fclose(hFile);
	return TRUE;
}

/******************************************************************************
 *	errSaveFile():	G[bZ[W\ăt@CN[Y
 ******************************************************************************
 *	:	FILE *hFile	N[Yt@Cnh
 *		int no		G[ԍ
 */
void errSaveFile(FILE *hFile, int no)
{
	switch (no) {
	case 1:
		DMError(D_CONFIRM, "t@C̃I[vł܂B");
		break;
	case 2:
		DMError(D_CONFIRM, "f[^t@C̍\ُłB");
		break;
	case 3:
		DMError(D_CONFIRM, "t@C݂̏Ɏs܂B");
		break;
	}
	/* t@CnhmtkkłȂ΃t@CN[Y */
	if (hFile)
		fclose(hFile);
}

/******************************************************************************
 *	checkDrive():	wt@C̃hCu`FbN
 ******************************************************************************
 *	:	char *fname	t@Cւ̃|C^
 *		int mode	郂[h
 *				=  0: 
 *				=  1: ǂݍ
 *	߂l:	int		>= 0: ǂݍݐ
 *				= -1: t@CȂ
 *				= -2: hCȕłĂȂ
 *				= -3: ݋֎~Ă
 *				= -4: t@C݂Ȃ
 */
int checkDrive(char *fname, int mode)
{
	int stat, errCode;
	struct NAMECKBUF nminf;
	char filbuf[TS_NAMEMAX];

	/* ͂ꂽt@C𕪉E */
	stat = NAMECK((unsigned char *) fname, &nminf);
	if (stat != 0) {
		DMError(D_CONFIRM, "t@C܂B");
		return -1;
	}
	/* tpX쐬 */
	strmfn(fname, (char *) nminf.drive, (char *) nminf.path, (char *) nminf.name, (char *) nminf.ext);

	/* wt@C̃hCȕԂ擾 */
	stat = TSDrvctrl(0, nminf.drive[0] & 0x1f);
	/* hCuĂ邩`FbN */
	if ((stat & 0x06) != 0x02) {
		DMError(D_CONFIRM, "hCȕłĂ܂B");
		return -2;
	}
	/* veNgĂ邩ǂ`FbN */
	if (mode == 0 && (stat & 0x0a) == 0x0a) {
		DMError(D_CONFIRM, "CgveNgĂ܂B\r"
				   "݂sƂł܂B");
		return -3;
	}
	/* t@C݂̑̃`FbN */
	errCode = TSFiles(filbuf, fname, TS_ARCH);
	if (errCode < 0)
		/* t@C̐VK쐬ꍇlāAG[_CAO͏oȂ */
		return -4;

	return 0;
}
